       program-id. readxls.
       environment division.
       configuration section.
       repository.
       class JFileInputStream as "java.io.FileInputStream"
       class JIOException as "java.io.IOException"
       class JHSSFCell as "org.apache.poi.hssf.usermodel.HSSFCell"
       class JCell as "org.apache.poi.ss.usermodel.Cell"
       class JHSSFRow as "org.apache.poi.hssf.usermodel.HSSFRow"
       class JHSSFSheet as "org.apache.poi.hssf.usermodel.HSSFSheet"
       class JHSSFWorkbook as 
        "org.apache.poi.hssf.usermodel.HSSFWorkbook"
       class JHSSFCellRangeAddress as 
        "org.apache.poi.ss.util.CellRangeAddress"
       class JCellType as "org.apache.poi.ss.usermodel.CellType"
       .
       data division.
       working-storage section.
       77 filename pic x any length.
       77 workbook object reference JHSSFWorkbook.
       77 num-sheets usage unsigned-int.
       77 num-rows usage unsigned-int.
       77 num-cells usage unsigned-int.
       77 k usage unsigned-int.
       77 r usage unsigned-int.
       77 c usage unsigned-int.
       77 jcell-obj object reference JCell.
       77 celltype-obj object reference JCellType.
       77 sheet-obj object reference JHSSFSheet.
       77 row-obj object reference JHSSFRow.
       77 cell-obj object reference JHSSFCell.
       77 cell-value pic x any length.
       77 obj object reference "java.lang.Object".

       procedure division chaining filename.
       main.
            if filename is = spaces then
               display "Usage: java READXLS <filename>"
               goback
            end-if
            display "Reading " filename "...".
            perform read-file.
            goback.

       read-file.
            try
              set workbook to 
                JHSSFWorkbook:>new(JFileInputStream:>new(filename))
            catch JIOException 
              exception-object:>printStackTrace()
            end-try.
            try
              display " "
              display "Data dump:"
      *How many sheets in this spreadsheet?
              set num-sheets to workbook:>getNumberOfSheets()
      *Read each sheet
              perform varying k from 0 by 1 until k >= num-sheets 
                set sheet-obj to workbook:>getSheetAt(k) as JHSSFSheet
      *How many rows in the current sheet?
                set num-rows to sheet-obj:>getPhysicalNumberOfRows()
                display " "
                display " "
                display "Sheet " k ' "' workbook:>getSheetName(k) '"' 
                        " has " num-rows " row(s)."
      *Read each row
                perform varying r from 0 by 1 until r >= num-rows
                  set row-obj to sheet-obj:>getRow(r) as JHSSFRow
      *If there is content in the row, How many cells in this row?
                  if row-obj is not = null
                    set num-cells to row-obj:>getPhysicalNumberOfCells()
                    
                    display "  ROW " row-obj:>getRowNum() " has " 
                        num-cells " cell(s)."
      *Read each cell
                    perform varying c from 0 by 1 until c >= num-cells
                      set jcell-obj to row-obj:>getCell(c)
                     
      *Get the cell type for this cell                      
      *Checking for three types:  Formula, Numeric, and STRING
                      set celltype-obj to jcell-obj:>getCellTypeEnum()
                      evaluate true
                        when celltype-obj = JCellType:>FORMULA
                          set cell-value to jcell-obj:>getCellFormula() 
                        
                        when celltype-obj = JCellType:>NUMERIC
                          set cell-value to 
                                  jcell-obj:>getNumericCellValue()
                          
                        when celltype-obj = JCellType:>STRING
                          set cell-value to 
                           jcell-obj:>getStringCellValue()
                          
                      end-evaluate
      *Display the cell type and content
                      display "    Col " jcell-obj:>getColumnIndex()
                        " is a " celltype-obj ", VALUE=" cell-value
                    end-perform
                  end-if
                end-perform
              end-perform
            catch Exception
              exception-object:>printStackTrace()
            end-try.

